package poker

import "github.com/stretchr/testify/assert"
import "testing"

type ShuffleTestResults []struct {
	SeedVal  int64
	Expected string
}

func TestPokerDeck(t *testing.T) {
	d := NewDeckFromSeed(437)
	cards := d.Deal(7)
	expected := "7♣,5♠,Q♠,2♦,6♦,Q♣,3♥"
	assert.Equal(t, cards.String(), expected)

	x := d.Remaining()
	assert.Equal(t, 45, x)

	d = NewDeckFromSeed(123456789)
	cards = d.Deal(10)
	expected = "5♥,4♥,5♠,2♣,6♦,6♣,3♦,Q♠,8♥,A♣"
	assert.Equal(t, expected, cards.String())
	x = d.Remaining()
	assert.Equal(t, 42, x)

}
